#!/bin/bash
#
# A shell script to pick the sha256 of an Homebrew bottle from a brew-generated JSON file.
#
# Input arguments:
#
# - The formula name.
# - The revision tag bottles have been built for: e.g., '4.2.0'. 
#   The tag is used to pick the right JSON file, which is generated by brew while building the bottle.
# - The macOS version we want to pick the sha256 for.
#   This is used to pick the right sha256 from the JSON file.
#
# Written by: Riccardo Maria BIANCHI - riccardo.maria.bianchi@cern.ch 
# Created:         May 2021 
# Last updated on: Dec 2022
# -------------------------------------------------------
#
#
# Examples of useful 'jq' commands:
#
# - this picks the sha256 for the big_sur bottle for the atlas/geomodel/geomodel formula:
#
#   jq .'"atlas/geomodel/geomodel"'.bottle.tags.big_sur.sha256 geomodel--4.2.1.big_sur.bottle.json
#
# - this will print the top-level keys, i.e., the tap/formula entries:
#
#  jq 'keys' geomodel--4.2.1.big_sur.bottle.json
#
# - This will descent into the JSON tree and prints all macOS versions and sha256, for each formula
#
# jq -r 'objects | to_entries[] | [.key, [.value.bottle.tags | to_entries[] | [.key, .value.sha256] | join(";") ] ]' geomodel--4.2.1.big_sur.bottle.json
#
# - This will get the sha256 for the 'big_sur' macOS version:
#
# jq -r 'objects | to_entries[] | .value.bottle.tags.big_sur? | .sha256' geomodel--4.2.1.big_sur.bottle.json
#
#

usage() {
    [ $# -eq 0 ] && { echo "\nUsage: $(basename $0) formulaName tag macOSVersion\n"; exit 1; }
}


# check if 'jq' is installed
if ! command -v jq &> /dev/null
then
    echo "\n\nERROR!! 'jq' could not be found! Please install it before launching this... Exiting.\n\n"
    exit
fi


# == INPUT DATA ==
formula=$1 # e.g., "geomodel"
tag=$2     # e.g., "4.2.1"
macos=$3   # e.g., "big_sur"
# tap=$4     # e.g., "atlas/geomodel"

if [[ -z "${formula}" ]]; then echo "ERROR - formula name is missing"; usage; exit; fi
if [[ -z "${tag}" ]]; then echo     "ERROR - tag is missing"; usage; exit; fi
if [[ -z "${macos}" ]]; then echo   "ERROR - macOS version name is missing"; usage; exit; fi
# if [[ -z "${tap}" ]]; then echo     "ERROR - tap name is missing"; usage; exit; fi


# NOTE: we have to open-close-open-close the single quotes, otherwise the 'macos' variable is not expanded
SUB='thirdparty'
if [[ "$formula" == *"$SUB"* ]]; then
    #echo "It's a 'thirdparty' formula. Searching for a suitable .json file and call jq on that..."
    filename=`find . -name "*${formula}*${macos}.bottle.json"`
    #echo "Found this .json formula file: $filename"
    jq -r 'objects | to_entries[] | .value.bottle.tags.'${macos}'? | .sha256' ${filename}
else
    jq -r 'objects | to_entries[] | .value.bottle.tags.'${macos}'? | .sha256' ${formula}--${tag}.${macos}.bottle.json
fi




